<template>
  <a-spin :spinning="isPosting" size="large" tip="Đang tải dữ liệu">
    <a-card :bordered="false" class="container">
      <a-form :form="form">
        <section v-if="isAdmin" class="group-section mb-lg">
          <div :style="cssVars" class="group-section-topic">
            Thông tin Giám sát viên
          </div>
          <div class="group-form-item">
            <a-form-item v-bind="formItemLayout">
              <template slot="label">
                <span>Giám sát viên</span>
              </template>
              <a-select
                v-decorator="['supervisorId', formItemOption.supervisorId]"
                :get-popup-container="triggerNode => triggerNode.parentNode"
                placeholder="Giám sát viên"
              >
                <a-select-option v-for="s in supervisors" :key="s.id">
                  {{ s.gender | NamePrefix }}{{ s.name }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </div>
        </section>
        <section class="group-section mb-lg">
          <div :style="cssVars" class="group-section-topic">
            Thông tin đăng nhập
          </div>
          <div class="group-form-item">
            <a-form-item v-bind="formItemLayout">
              <template slot="label">
                <span>Tài khoản đăng nhập</span>
              </template>
              <a-input
                v-decorator="['username', formItemOption.usernameDecorator]"
                placeholder=""
              />
            </a-form-item>
          </div>
          <div class="group-form-item">
            <a-form-item v-bind="formItemLayout">
              <template slot="label">
                <span>Địa chỉ email</span>
              </template>
              <a-input
                v-decorator="['email', formItemOption.emailDecorator]"
                placeholder=""
              />
            </a-form-item>
          </div>
        </section>
        <section class="group-section mb-lg">
          <div :style="cssVars" class="group-section-topic">
            Thông tin Khách hàng
          </div>
          <div class="group-form-item">
            <a-form-item v-bind="formItemLayout">
              <template slot="label">
                <span>Họ và tên</span>
              </template>
              <a-input
                v-decorator="['name', formItemOption.nameDecorator]"
                placeholder="Họ và tên"
              />
            </a-form-item>
          </div>
          <div class="group-form-item">
            <a-form-item v-bind="formItemLayout">
              <template slot="label">
                <span>Giới tính</span>
              </template>
              <a-select
                v-decorator="['gender', formItemOption.genderDecorator]"
                :get-popup-container="triggerNode => triggerNode.parentNode"
                placeholder="Giới tính"
              >
                <a-select-option v-for="value in genders" :key="value.key">
                  {{ value.label }}
                </a-select-option>
              </a-select>
            </a-form-item>
          </div>
          <div class="group-form-item">
            <a-form-item v-bind="formItemLayout">
              <template slot="label">
                <span>Số điện thoại</span>
              </template>
              <a-input
                v-decorator="['telecom', formItemOption.telecomDecorator]"
                placeholder="Số điện thoại"
              >
                <a-select
                  slot="addonBefore"
                  v-decorator="['prefix', { initialValue: '84' }]"
                  style="width: 70px"
                >
                  <a-select-option value="84">
                    +84
                  </a-select-option>
                </a-select>
              </a-input>
            </a-form-item>
          </div>
        </section>
      </a-form>
      <a-row type="flex" justify="center" align="middle">
        <a-col :lg="6" :xs="24">
          <a-button
            @click.stop.prevent="handlePostPatient"
            :loading="isPosting"
            type="primary"
            class="group-submit-btn"
            icon="plus"
          >
            Tạo Nhân viên CSKH
          </a-button>
        </a-col>
      </a-row>
    </a-card>
  </a-spin>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import { ehrApi } from '@/api'
export default {
  data () {
    return {
      form: this.$form.createForm(this),
      isPosting: false,
      genders: [
        { key: 'male', label: 'Nam' },
        { key: 'female', label: 'Nữ' }
      ],
      supervisors: []
    }
  },
  computed: {
    ...mapGetters('app', ['color']),
    ...mapGetters('auth', ['userId', 'role', 'isAdmin', 'isSupervisor']),
    cssVars () {
      return {
        '--color': this.color
      }
    },
    formItemLayout: () => ({}),
    rules () {
      return {
        name: [
          { required: true, message: 'Vui lòng nhập họ và tên' }
        ],
        address: [
          { required: false }
        ],
        birthDate: [
          { required: true, message: 'Vui lòng nhập ngày sinh' }
        ],
        username: [
          { required: true, message: 'Vui lòng nhập tên tài khoản' },
          { validator: this.validateUsername }
        ],
        email: [
          { required: true, type: 'email', message: 'Vui lòng nhập chính xác email' },
          { validator: this.validateEmail }
        ],
        telecom: [
          { required: true, message: 'Vui lòng nhập số điện thoại' },
          { validator: this.validateTelecom }
        ],
        gender: [
          { required: true, message: 'Vui lòng chọn giới tính' }
        ],
        supervisorId: [
          { required: true, message: 'Vui lòng chọn Giám sát viên' }
        ]
      }
    },
    formItemOption () {
      const { rules } = this
      return {
        nameDecorator: {
          rules: rules.name,
          initialValue: ''
        },
        addressDecorator: {
          rules: rules.address,
          initialValue: ''
        },
        birthDateDecorator: {
          rules: rules.birthDate,
          initialValue: null
        },
        supervisorId: {
          rules: rules.supervisorId,
          initialValue: '',
          validateTrigger: ['blur']
        },
        usernameDecorator: {
          rules: rules.username,
          initialValue: '',
          validateTrigger: ['blur']
        },
        emailDecorator: {
          rules: rules.email,
          initialValue: '',
          validateTrigger: ['blur']
        },
        telecomDecorator: {
          rules: rules.telecom,
          initialValue: ''
        },
        genderDecorator: {
          rules: rules.gender,
          initialValue: 'male'
        }
      }
    }
  },
  async created () {
    if (this.isAdmin) {
      const filter = {
        where: {},
        limit: 1000,
        order: 'name ASC'
      }
      const { data } = await ehrApi.admin.getSupervisors({ filter })
      this.supervisors = data
    }
  },
  methods: {
    ...mapActions('supporter', ['addSupporter']),
    validateTelecom (rule, value, callback) {
      const regex = /^\d+$/
      const isNumber = regex.test(value)
      const maxLenght = value.toString().length < 9 || value.toString().length > 10
      if (value && !isNumber) {
        callback('Số điện thoại chỉ gồm các chữ số')
      }
      if (value && maxLenght) {
        callback('Số điện thoại phải từ 9 - 11 kí tự')
      }
      callback()
    },
    async validateUsername (rule, value, callback) {
      try {
        if (value) {
          const maxLenght = value.toString().length < 8
          if (maxLenght) {
            throw new Error('Tên đăng nhập phải có ít nhất 8 kí tự')
          }
          const { created } = await ehrApi.validate.username({ username: value })
          if (created) {
            throw new Error('Tên đăng nhập này đã tồn tại')
          }
        }
      } catch (error) {
        callback(error)
      }
    },
    async validateEmail (rule, value, callback) {
      try {
        if (value) {
          const { created } = await ehrApi.validate.email({ email: value })
          if (created) {
            throw new Error('Địa chỉ email này đã tồn tại')
          }
        }
      } catch (error) {
        callback(error)
      }
    },
    handlePostPatient () {
      const {
        form: { validateFields }
      } = this
      const validateFieldsKey = [(this.isAdmin && 'supervisorId'), 'email', 'username', 'name', 'telecom', 'gender']
      console.log(validateFieldsKey)
      validateFields(validateFieldsKey, { force: true }, async (err, values) => {
        if (!err) {
          try {
            this.isPosting = true
            const param = {
              ...values,
              ...(this.isSupervisor && { supervisorId: this.userId })
            }
            const supporter = await ehrApi[this.role].createSupporter(param)
            await this.addSupporter(supporter)
            this.notiSuccess('Tạo Nhân viên CSKH thành công')
            this.$router.push({ name: 'list-supporter' })
          } catch (error) {
            this.notiError(error)
          } finally {
            this.isPosting = false
          }
        }
      })
    },
    notiSuccess (message) {
      this.$notification.success({
        message: message || 'Thành công',
        duration: 4
      })
    },
    notiError (err) {
      this.$notification.error({
        message: 'Lỗi',
        description: 'Đã xảy ra lỗi' || err.message,
        duration: 4
      })
    }
  }
}
</script>
<style lang="scss" scoped>
@import "@/assets/scss/jobs/box-layout.scss";
</style>
